#ifndef __TCP_H
#define __TCP_H


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/wait.h>
#include <signal.h>
#include <dirent.h>
#include "utils/network.h"


#define SHARE "shared" // the shared directory

#define BACKLOG 10	 // how many pending connections queue will hold
#define FILE_BUF_SIZE 1000*1024 // 100 kB 
#define MAXBUFLEN 256

int send_dir(int sockfd, char *dir);
int send_file(int sockfd, char *fname);
void *start_tcp_server(void *);

int connect_to_host(int ip, int port);

int request_file_list(int sockfd);
int receive_file_list(int sockfd);
int receive_and_write_file_list(int sockfd, char *fname);

int request_file(int sockfd, char *fname);
int receive_file(int sockfd, char *fname);
void* get_file(void *ptr);

struct FileInfo {
	int sockfd;
	FILE *fp;
	int file_size;
};

struct FileInfo fInfo;
#endif
